SystemOrganization addCategory: #'PW-Pages'!

ALAsyncExample subclass: #PWConfigPage
	instanceVariableNames: 'integer something'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PW-Pages'!

!PWConfigPage commentStamp: 'chc 6/29/2016 07:20' prior: 0!
Pages respond to #renderContentOn:. Components respond to #renderOn: !

!PWConfigPage methodsFor: 'as yet unclassified' stamp: 'chc 1/7/2016 18:45'!
initialize
	integer := 'off'.
	something := 'Coco Beware'! !

!PWConfigPage methodsFor: 'as yet unclassified' stamp: 'chc 3/29/2016 11:54'!
installerScriptForPEGWiki
	^'Installer ss3 project: ''PEGWiki'';
	install: ''PEGWiki-Model'';
 	install: ''PEGWiki-Core'';
	install: ''PEGWiki-PEG'';
	install: ''PEGWiki-Resources'';
	install: ''PEGWiki-Examples'''! !

!PWConfigPage methodsFor: 'as yet unclassified' stamp: 'chc 2/1/2016 13:50'!
renderAttribute: anAttribute on: anHtmlCanvas

	! !

!PWConfigPage methodsFor: 'as yet unclassified' stamp: 'chc 6/27/2016 08:55'!
renderContentOn: html
	| shell |
	"shell := CommandShell new."
	html form beMethodGet; with:
		[ html p: 'Show wiki syntax form for editing page content: '.
			html input 
			beTypeRadio;
			value: 'on';
			callback: [:str | PWSeasidePrefsModel instance takeValue: str forAttribute: (WAStringAttribute key: #render group: #wikidata). ];
			with: [html text: 'On'].
		html br. 
		html input beTypeRadio;
			value: 'off';
			callback: [:str | PWSeasidePrefsModel instance takeValue: str forAttribute: (WAStringAttribute key: #render group: #wikidata). ];
			with: [html text: 'Off'].
		html br.
		html input beTypeSubmit; value: 'Save'.
		html br.
		html text: (PWSeasidePrefsModel instance valueAt: #render) ].
	
		"html table with: [ 
			PWSeasidePrefsModel instance groupedAttributes do: [:association| 
					html tr with: [
						html td colspan: '2'; with: [ html h3: (self labelForSelector: association key).
							association value do: [ :attribute |
								self renderAttribute: attribute on: html ]
				 			]]]].
		html br.
		html table
			with: [html tr
				with: [html td with: 'Port'.
					html td with: '8624']].
		html textarea."
		html p: 'Installer script form:'. html br. 
		html form beMethodGet; with:
		[html textarea 
			"beTypeText"
			"size: '100';"
			"value: 'Installer ss project: ''Games''; install: ''MorphicGames-md.1.mcz''';"
			callback: [:str | Compiler evaluate: str unescapePercents "integer := str ""asNumber"];
			with: [ "html text: 'Installer ss project: ''Games''; install: ''MorphicGames-md.1.mcz'''" html text: self installerScriptForPEGWiki ].
		html br.
		html input beTypeSubmit.
		"html text: integer asWords"].
	html p: 'Purge code to default and restart image:'. html br. 
	html a 
		class: 'action';
		callback: [ shell command: '/home/ooplu/vm/working/cogspurlinuxht/squeak   -vm display=none /home/ooplu/images/working/Squeak5.0-15113.image &'.
					SmalltalkImage current snapshot: false andQuit: true
		]; 
		with: 'Restart'.
		self renderStyleOn: html.
		
		
		
		! !

!PWConfigPage methodsFor: 'as yet unclassified' stamp: 'chc 1/28/2016 12:32'!
renderStyleOn: html
	^ html style: '
			table, tr, td {border: 1px solid green;}'! !

ALExample subclass: #PWFormView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PW-Pages'!

!PWFormView commentStamp: 'chc 6/29/2016 07:23' prior: 0!
Show a form to create a nea page.!

!PWFormView methodsFor: 'as yet unclassified' stamp: 'chc 6/29/2016 07:22'!
libraryScript

	^ '
function Counter(url) {
  this.update(url);
};

Counter.prototype.install = function Counter_install(count, dec, inc) {
  var self = this;
  this.count = $(count);
  $(dec).click(function() {self.update(self.state.dec)});
  $(inc).click(function() {self.update(self.state.inc);});
};

Counter.prototype.update = function Counter_update(url) {
  var self = this;
  $.getJSON(url, function(json) {
    self.state = json;
    self.count.html(self.state.count);
  });
};
'! !

!PWFormView methodsFor: 'as yet unclassified' stamp: 'chc 6/30/2016 08:37'!
renderContentOn: html
	html span
	"	class: 'counter';"
		id: 'count';
		with: '0'.
((PWSeasidePrefsModel instance valueAt: #render) = 'on') ifTrue: [
	html form id: 'myform'; beMethodPost; with:
		[html textarea name: 'wikiString'; with: [ html text: (PWSeasidePrefsModel instance valueAt: #currentString)].
		 html br. 
		 html input beTypeSubmit ]]. 
	self renderScriptsOn: html! !

!PWFormView methodsFor: 'as yet unclassified' stamp: 'chc 6/29/2016 07:22'!
renderFormScriptOn: html

	html raw: 
		'function ConvertFormToJson(form) {
			var array = (form).serializeArray();
			var json = {};
			jQuery.each( array, function () {
			json[this.name] = this.value || '' '';
		});
		return json;
		}

		$(myform).submit(function(event){
		event.preventDefault();

		var json = ConvertFormToJson($(myform));
		console.log(json);

		jsonstring = JSON.stringify(json);
		console.log(jsonstring);

		$.ajax({
		type: "POST",
		url: "'.

	html text: (html context registerResource: self resource) printString.

	html raw: 
		'",
		data: jsonstring,
		success: function (data) {
					var self = this;
					self.state = data;
					$(''#count'').html(self.state.count);
									}
		}) 
							});'! !

!PWFormView methodsFor: 'as yet unclassified' stamp: 'chc 6/29/2016 07:22'!
renderInitScriptOn: html

	html raw: 'var counter = new Counter("'.
	html text: (html context registerResource: self resource) printString.
	html raw: '"); counter.install("#count", "#dec", "#inc");' ! !

!PWFormView methodsFor: 'as yet unclassified' stamp: 'chc 6/29/2016 07:27'!
renderScriptsOn: html
	html script src: 'https://ajax.googleapis.com/ajax/libs/jquery/1.7.2/jquery.min.js'.
	html script src: 'http://localhost:8624/jquery.form.js'.
	html script type: 'application/javascript'; with: [html raw: self libraryScript].
	html script type: 'application/javascript'; with: [self renderFormScriptOn: html].
	html script type: 'application/javascript'; with: [self renderInitScriptOn: html]! !

!PWFormView methodsFor: 'as yet unclassified' stamp: 'chc 6/29/2016 07:28'!
resource
	| wikiString wikiGrammar parser html |
	wikiString := PWSeasidePrefsModel instance valueAt: #currentString.
	wikiGrammar := PEGParser grammarWiki.
	parser := PEGParser parserPEG parse: 'Grammar' stream: wikiGrammar actor: PEGParserParser new.
	html := parser parse: 'Page' stream: wikiString actor: PWActor new.
	^ ALJsonResource component: (PWAjaxComponent html: html)! !

ALExample subclass: #PWPageView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PW-Pages'!

!PWPageView commentStamp: 'chc 6/29/2016 07:23' prior: 0!
Show a single wiki page. !

!PWPageView methodsFor: 'as yet unclassified' stamp: 'chc 6/21/2016 08:37'!
libraryScript

	^ '
function Counter(url) {
  this.update(url);
};

Counter.prototype.install = function Counter_install(count, dec, inc) {
  var self = this;
  this.count = $(count);
  $(dec).click(function() {self.update(self.state.dec)});
  $(inc).click(function() {self.update(self.state.inc);});
};

Counter.prototype.update = function Counter_update(url) {
  var self = this;
  $.getJSON(url, function(json) {
    self.state = json;
    self.count.html(self.state.count);
  });
};
'! !

!PWPageView methodsFor: 'as yet unclassified' stamp: 'chc 6/29/2016 06:52'!
renderContentOn: html
	html span
		class: 'counter';
		id: 'count';
		with: '0'.
((PWSeasidePrefsModel instance valueAt: #render) = 'on') ifTrue: [
	html form id: 'myform'; beMethodPost; with:
		[html textarea name: 'wikiString'; with: [ html text: (PWSeasidePrefsModel instance valueAt: #currentString)].
		 html br. 
		 html input beTypeSubmit ]]. 
	self renderScriptsOn: html! !

!PWPageView methodsFor: 'as yet unclassified' stamp: 'chc 6/21/2016 08:37'!
renderFormScriptOn: html

	html raw: 
		'function ConvertFormToJson(form) {
			var array = (form).serializeArray();
			var json = {};
			jQuery.each( array, function () {
			json[this.name] = this.value || '' '';
		});
		return json;
		}

		$(myform).submit(function(event){
		event.preventDefault();

		var json = ConvertFormToJson($(myform));
		console.log(json);

		jsonstring = JSON.stringify(json);
		console.log(jsonstring);

		$.ajax({
		type: "POST",
		url: "'.

	html text: (html context registerResource: self resource) printString.

	html raw: 
		'",
		data: jsonstring,
		success: function (data) {
					var self = this;
					self.state = data;
					$(''#count'').html(self.state.count);
									}
		}) 
							});'! !

!PWPageView methodsFor: 'as yet unclassified' stamp: 'chc 6/29/2016 07:29'!
renderInitScriptOn: html
	html raw: 'var counter = new Counter("'.
	html text: (html context registerResource: self resource) printString.
	html raw: '"); counter.install("#count", "#dec", "#inc");' ! !

!PWPageView methodsFor: 'as yet unclassified' stamp: 'chc 6/29/2016 07:28'!
renderScriptsOn: html
	html script src: 'https://ajax.googleapis.com/ajax/libs/jquery/1.7.2/jquery.min.js'.
	html script src: 'http://localhost:8624/jquery.form.js'.
	html script type: 'application/javascript'; with: [html raw: self libraryScript].
	html script type: 'application/javascript'; with: [self renderFormScriptOn: html].
	html script type: 'application/javascript'; with: [self renderInitScriptOn: html]! !

!PWPageView methodsFor: 'as yet unclassified' stamp: 'chc 6/29/2016 07:29'!
resource
	| wikiString wikiGrammar parser html |
	wikiString := PWSeasidePrefsModel instance valueAt: #currentString.
	wikiGrammar := PEGParser grammarWiki.
	parser := PEGParser parserPEG parse: 'Grammar' stream: wikiGrammar actor: PEGParserParser new.
	html := parser parse: 'Page' stream: wikiString actor: PWActor new.
	^ ALJsonResource component: (PWAjaxComponent html: html)! !
